﻿using UnityEngine.XR.Interaction.Toolkit.AR;
using UnityEngine.XR.Interaction.Toolkit.Inputs;
using UnityEngine.XR.Interaction.Toolkit.Inputs.Simulation;
using UnityEngine.XR.Interaction.Toolkit.UI;

namespace UnityEngine.XR.Interaction.Toolkit
{
    /// <summary>
    /// Constants for <see cref="HelpURLAttribute"/> for XR Interaction Toolkit.
    /// </summary>
    static partial class XRHelpURLConstants
    {
        /// <summary>
        /// Scripting API URL for <see cref="ActionBasedContinuousMoveProvider"/>.
        /// </summary>
        public const string k_ActionBasedContinuousMoveProvider = k_BaseApi + k_BaseNamespace + nameof(ActionBasedContinuousMoveProvider) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ActionBasedContinuousTurnProvider"/>.
        /// </summary>
        public const string k_ActionBasedContinuousTurnProvider = k_BaseApi + k_BaseNamespace + nameof(ActionBasedContinuousTurnProvider) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ActionBasedController"/>.
        /// </summary>
        public const string k_ActionBasedController = k_BaseApi + k_BaseNamespace + nameof(ActionBasedController) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ActionBasedSnapTurnProvider"/>.
        /// </summary>
        public const string k_ActionBasedSnapTurnProvider = k_BaseApi + k_BaseNamespace + nameof(ActionBasedSnapTurnProvider) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ARAnnotationInteractable"/>.
        /// </summary>
        public const string k_ARAnnotationInteractable = k_BaseApi + k_BaseNamespace + "AR." + nameof(ARAnnotationInteractable) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ARGestureInteractor"/>.
        /// </summary>
        public const string k_ARGestureInteractor = k_BaseApi + k_BaseNamespace + "AR." + nameof(ARGestureInteractor) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ARPlacementInteractable"/>.
        /// </summary>
        public const string k_ARPlacementInteractable = k_BaseApi + k_BaseNamespace + "AR." + nameof(ARPlacementInteractable) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ARRotationInteractable"/>.
        /// </summary>
        public const string k_ARRotationInteractable = k_BaseApi + k_BaseNamespace + "AR." + nameof(ARRotationInteractable) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ARScaleInteractable"/>.
        /// </summary>
        public const string k_ARScaleInteractable = k_BaseApi + k_BaseNamespace + "AR." + nameof(ARScaleInteractable) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ARSelectionInteractable"/>.
        /// </summary>
        public const string k_ARSelectionInteractable = k_BaseApi + k_BaseNamespace + "AR." + nameof(ARSelectionInteractable) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="ARTranslationInteractable"/>.
        /// </summary>
        public const string k_ARTranslationInteractable = k_BaseApi + k_BaseNamespace + "AR." + nameof(ARTranslationInteractable) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="CharacterControllerDriver"/>.
        /// </summary>
        public const string k_CharacterControllerDriver = k_BaseApi + k_BaseNamespace + nameof(CharacterControllerDriver) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="DeviceBasedContinuousMoveProvider"/>.
        /// </summary>
        public const string k_DeviceBasedContinuousMoveProvider = k_BaseApi + k_BaseNamespace + nameof(DeviceBasedContinuousMoveProvider) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="DeviceBasedContinuousTurnProvider"/>.
        /// </summary>
        public const string k_DeviceBasedContinuousTurnProvider = k_BaseApi + k_BaseNamespace + nameof(DeviceBasedContinuousTurnProvider) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="DeviceBasedSnapTurnProvider"/>.
        /// </summary>
        public const string k_DeviceBasedSnapTurnProvider = k_BaseApi + k_BaseNamespace + nameof(DeviceBasedSnapTurnProvider) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="InputActionManager"/>.
        /// </summary>
        public const string k_InputActionManager = k_BaseApi + k_BaseNamespace + "Inputs." + nameof(InputActionManager) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRDeviceSimulator"/>.
        /// </summary>
        public const string k_XRDeviceSimulator = k_BaseApi + k_BaseNamespace + "Inputs.Simulation." + nameof(XRDeviceSimulator) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="LocomotionSystem"/>.
        /// </summary>
        public const string k_LocomotionSystem = k_BaseApi + k_BaseNamespace + nameof(LocomotionSystem) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="TeleportationAnchor"/>.
        /// </summary>
        public const string k_TeleportationAnchor = k_BaseApi + k_BaseNamespace + nameof(TeleportationAnchor) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="TeleportationArea"/>.
        /// </summary>
        public const string k_TeleportationArea = k_BaseApi + k_BaseNamespace + nameof(TeleportationArea) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="TeleportationProvider"/>.
        /// </summary>
        public const string k_TeleportationProvider = k_BaseApi + k_BaseNamespace + nameof(TeleportationProvider) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="TrackedDeviceGraphicRaycaster"/>.
        /// </summary>
        public const string k_TrackedDeviceGraphicRaycaster = k_BaseApi + k_BaseNamespace + "UI." + nameof(TrackedDeviceGraphicRaycaster) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="TrackedDevicePhysicsRaycaster"/>
        /// </summary>
        public const string k_TrackedDevicePhysicsRaycaster = k_BaseApi + k_BaseNamespace + "UI." + nameof(TrackedDevicePhysicsRaycaster) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRUIInputModule"/>.
        /// </summary>
        public const string k_XRUIInputModule = k_BaseApi + k_BaseNamespace + "UI." + nameof(XRUIInputModule) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRController"/>.
        /// </summary>
        public const string k_XRController = k_BaseApi + k_BaseNamespace + nameof(XRController) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRControllerRecorder"/>.
        /// </summary>
        public const string k_XRControllerRecorder = k_BaseApi + k_BaseNamespace + nameof(XRControllerRecorder) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRControllerRecording"/>.
        /// </summary>
        public const string k_XRControllerRecording = k_BaseApi + k_BaseNamespace + nameof(XRControllerRecording) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRDirectInteractor"/>.
        /// </summary>
        public const string k_XRDirectInteractor = k_BaseApi + k_BaseNamespace + nameof(XRDirectInteractor) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRGrabInteractable"/>.
        /// </summary>
        public const string k_XRGrabInteractable = k_BaseApi + k_BaseNamespace + nameof(XRGrabInteractable) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRInteractionManager"/>.
        /// </summary>
        public const string k_XRInteractionManager = k_BaseApi + k_BaseNamespace + nameof(XRInteractionManager) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRInteractorLineVisual"/>.
        /// </summary>
        public const string k_XRInteractorLineVisual = k_BaseApi + k_BaseNamespace + nameof(XRInteractorLineVisual) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRInteractorReticleVisual"/>.
        /// </summary>
        public const string k_XRInteractorReticleVisual = k_BaseApi + k_BaseNamespace + nameof(XRInteractorReticleVisual) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRRayInteractor"/>.
        /// </summary>
        public const string k_XRRayInteractor = k_BaseApi + k_BaseNamespace + nameof(XRRayInteractor) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRSimpleInteractable"/>.
        /// </summary>
        public const string k_XRSimpleInteractable = k_BaseApi + k_BaseNamespace + nameof(XRSimpleInteractable) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRSocketInteractor"/>.
        /// </summary>
        public const string k_XRSocketInteractor = k_BaseApi + k_BaseNamespace + nameof(XRSocketInteractor) + ".html";

        /// <summary>
        /// Scripting API URL for <see cref="XRTintInteractableVisual"/>.
        /// </summary>
        public const string k_XRTintInteractableVisual = k_BaseApi + k_BaseNamespace + nameof(XRTintInteractableVisual) + ".html";

        const string k_BaseApi = "https://docs.unity3d.com/Packages/com.unity.xr.interaction.toolkit@2.0/api/";
        const string k_BaseNamespace = "UnityEngine.XR.Interaction.Toolkit.";
    }
}
